package com.tzld.piaoquan.ad.engine.commons.base;

import lombok.Data;

import java.util.HashMap;
import java.util.Map;

@Data
public class UserAdBytesFeature {

    private final byte[] mid;

    private final byte[] gender;
    private final byte[] user_type;
    private final byte[] gmt_create;
    private final byte[] tags;
    private final byte[] category_name;
    private final byte[] isvip;
    private final byte[] isreward;
    private final byte[] isad;
    private final byte[] isgood;

    private final byte[] first_up_datetime;
    private final byte[] last_up_datetime;
    private final byte[] next_to_last_up_datetime;
    private final byte[] videos; // 上传视频数量
    private final byte[] idols; // 关注人数
    private final byte[] fans;  // 粉丝数
    private final byte[] play_count;  // 播放人数
    private final byte[] play_count_total;  // 累计播放次数

    private final byte[] total_reward;
    private final byte[] currentday_reward;
    private final byte[] reward_person;
    private final byte[] total_reward_times;

    private final byte[] reward_videos;
    private final byte[] total_price;
    private final byte[] currentday_price;
    private final byte[] total_price_times;
    private final byte[] total_price_person;
    private final byte[] total_price_videos;
    private final byte[] cgrain_user_type;
    private final byte[] identity_tagname;


    private final byte[] operation_tags;
    private final byte[] identity_tag_id;
    private final byte[] identity_create_time;
    private final byte[] country;
    private final byte[] province;
    private final byte[] city;


    // 当天统计量信息
    private Map<String, byte[]> day1_cnt_features;
    // 3天内统计量
    private Map<String, byte[]> day3_cnt_features;
    // 7天内统计量
    private Map<String, byte[]> day7_cnt_features;
    // 3个月统计量
    private Map<String, byte[]> month3_cnt_features;


    public UserAdBytesFeature(UserAdFeature feature) {
        this.mid = feature.getMid().getBytes();


        this.gender = feature.getGender().getBytes();
        this.user_type = feature.getUser_type().getBytes();
        this.gmt_create = feature.getGmt_create().getBytes();
        this.tags = feature.getTags().getBytes() ;
        this.category_name = feature.getCategory_name().getBytes();
        this.isvip = feature.getIsvip().getBytes();
        this.isreward = feature.getIsreward().getBytes();
        this.isad = feature.getIsad().getBytes();
        this.isgood = feature.getIsgood().getBytes();

        this.first_up_datetime = feature.getFirst_up_datetime().getBytes();
        this.last_up_datetime = feature.getLast_up_datetime().getBytes();
        this.next_to_last_up_datetime = feature.getNext_to_last_up_datetime().getBytes();
        this.videos = feature.getVideos().getBytes(); // 上传视频数量
        this.idols = feature.getIdols().getBytes(); // 关注人数
        this.fans = feature.getFans().getBytes();  // 粉丝数
        this.play_count = feature.getPlay_count().getBytes();  // 播放人数
        this.play_count_total = feature.getPlay_count_total().getBytes();  // 累计播放次数

        this.total_reward = feature.getTotal_reward().getBytes();
        this.currentday_reward = feature.getCurrentday_reward().getBytes();
        this.reward_person = feature.getReward_person().getBytes();
        this.total_reward_times = feature.getTotal_reward_times().getBytes();

        this.reward_videos = feature.getReward_videos().getBytes();
        this.total_price = feature.getTotal_price().getBytes();
        this.currentday_price = feature.getCurrentday_price().getBytes();
        this.total_price_times = feature.getTotal_price_times().getBytes();
        this.total_price_person = feature.getTotal_price_person().getBytes();
        this.total_price_videos = feature.getTotal_price_videos().getBytes();
        this.cgrain_user_type = feature.getCgrain_user_type().getBytes();
        this.identity_tagname = feature.getIdentity_tagname().getBytes();


        this.operation_tags = feature.getOperation_tags().getBytes();
        this.identity_tag_id = feature.getIdentity_tag_id().getBytes();
        this.identity_create_time = feature.getIdentity_create_time().getBytes();
        this.country = feature.getCountry().getBytes();
        this.province = feature.getProvince().getBytes();
        this.city = feature.getCity().getBytes();



        // 1 day statistic
        day1_cnt_features = new HashMap<String, byte[]>();
        day1_cnt_features.put("view", String.valueOf(feature.getDay1_cnt_features().getAdView()).getBytes());
        day1_cnt_features.put("click", String.valueOf(feature.getDay1_cnt_features().getAdClick()).getBytes());
        day1_cnt_features.put("conversion", String.valueOf(feature.getDay1_cnt_features().getAdConversion()).getBytes());
        day1_cnt_features.put("ctr", String.valueOf(feature.getDay1_cnt_features().getCtr()).getBytes());
        day1_cnt_features.put("cvr", String.valueOf(feature.getDay1_cnt_features().getCvr()).getBytes());




        // 3 day statistic
        day3_cnt_features = new HashMap<String, byte[]>();
        day3_cnt_features.put("view", String.valueOf(feature.getDay3_cnt_features().getAdView()).getBytes());
        day3_cnt_features.put("click", String.valueOf(feature.getDay3_cnt_features().getAdClick()).getBytes());
        day3_cnt_features.put("conversion", String.valueOf(feature.getDay3_cnt_features().getAdConversion()).getBytes());
        day3_cnt_features.put("ctr", String.valueOf(feature.getDay3_cnt_features().getCtr()).getBytes());
        day3_cnt_features.put("cvr", String.valueOf(feature.getDay3_cnt_features().getCvr()).getBytes());


        // 7 day statistic
        day7_cnt_features = new HashMap<String, byte[]>();
        day7_cnt_features.put("view", String.valueOf(feature.getDay7_cnt_features().getAdView()).getBytes());
        day7_cnt_features.put("click", String.valueOf(feature.getDay7_cnt_features().getAdClick()).getBytes());
        day7_cnt_features.put("conversion", String.valueOf(feature.getDay7_cnt_features().getAdConversion()).getBytes());
        day7_cnt_features.put("ctr", String.valueOf(feature.getDay7_cnt_features().getCtr()).getBytes());
        day7_cnt_features.put("cvr", String.valueOf(feature.getDay7_cnt_features().getCvr()).getBytes());


        // 3 month statisic
        month3_cnt_features = new HashMap<String, byte[]>();
        month3_cnt_features.put("view", String.valueOf(feature.getMonth3_cnt_features().getAdView()).getBytes());
        month3_cnt_features.put("click", String.valueOf(feature.getMonth3_cnt_features().getAdClick()).getBytes());
        month3_cnt_features.put("conversion", String.valueOf(feature.getMonth3_cnt_features().getAdConversion()).getBytes());
        month3_cnt_features.put("ctr", String.valueOf(feature.getMonth3_cnt_features().getCtr()).getBytes());
        month3_cnt_features.put("cvr", String.valueOf(feature.getMonth3_cnt_features().getCvr()).getBytes());



    }


}
